﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace PrintWaterMark
{
    public class OrderInfo : INotifyPropertyChanged
    {
        #region Private members

        private int _orderId;
        private string _customerId;
        private string _productName;
        private double _unitPrice;
        private int _quantiy;
        private double _discount;
        private double _freight;
        private DateTime _orderDate;
        private string _shipCity;
        private string _shipCountry;
        private DateTime _shippedDate;
        private string _contactNumber;
        private bool isClosed;

        #endregion

        #region Public properties

        public int OrderID
        {
            get { return _orderId; }
            set
            {
                _orderId = value;
                RaisePropertyChanged("OrderID");
            }
        }

        public bool IsClosed
        {
            get { return isClosed; }
            set
            {
                isClosed = value;
                RaisePropertyChanged("IsClosed");
            }
        }

        public string CustomerID
        {
            get { return _customerId; }
            set
            {
                _customerId = value;
                RaisePropertyChanged("CustomerID");
            }
        }

        public string ProductName
        {
            get { return _productName; }
            set
            {
                _productName = value;
                RaisePropertyChanged("ProductName");
            }
        }

        public string ContactNumber
        {
            get { return _contactNumber; }
            set
            {
                _contactNumber = value;
                RaisePropertyChanged("ContactNumber");
            }
        }

        public double UnitPrice
        {
            get { return _unitPrice; }
            set { _unitPrice = value; }
        }

        public int Quantity
        {
            get { return _quantiy; }
            set
            {
                _quantiy = value;
                RaisePropertyChanged("Quantity");
            }
        }

        public double Discount
        {
            get { return _discount; }
            set
            {
                _discount = value;
                RaisePropertyChanged("Discount");
            }
        }

        public double Freight
        {
            get { return _freight; }
            set
            {
                _freight = value;
                RaisePropertyChanged("Freight");
            }
        }

        public DateTime OrderDate
        {
            get { return _orderDate; }
            set
            {
                _orderDate = value;
                RaisePropertyChanged("OrderDate");
            }
        }

        public DateTime ShippedDate
        {
            get { return _shippedDate; }
            set
            {
                _shippedDate = value;
                RaisePropertyChanged("ShippedDate");
            }
        }

        public string ShipCity
        {
            get { return this._shipCity; }
            set
            {
                this._shipCity = value;
                this.RaisePropertyChanged("ShipCity");
            }
        }

        public string ShipCountry
        {
            get { return this._shipCountry; }
            set
            {
                this._shipCountry = value;
                this.RaisePropertyChanged("ShipCountry");
            }
        }

        #endregion

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void RaisePropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
